﻿/// <reference path="../jquery.js" />
/// <reference path="../dq.js" />

/*
* DQ Retro game UI framework JavaScript library version v0.6.0
*
* Copyright (c) 2009-2010 M., Koji
* Licensed under the MIT License: http://www.opensource.org/licenses/mit-license.php
*
* Date: 2009-11-01 17:34:21 -0900
* Revision: 0008
*/

DQ.lazyLoad(DQ.subdir + "rpg/dq-rpg.js", "DQ.RPG.InputBox", function () {
    DQ.Event = function (options) {
        /// <summary>
        ///     個々のイベントの内容を保持します。
        ///     [type] message: メッセージを表示します
        options = DQ.options(options, {
            type: 'message',
            message: [],
            position: [-1, -1],
            conditions: [],
            post: [],
            pre: [],
            name: "",
            data: {}
        });

        this.type = options.type;
        this.message = options.message;
        this.position = options.position;
        this.conditions = options.conditions;
        this.pre = options.pre;
        this.post = options.post;
        this.name = options.name;
        this.data = options.data;

    }

    DQ.Event.prototype = {
        deltaX: 0,
        deltaY: 0,
        type: "",
        message: [],
        position: [],
        conditions: [],
        post: [],
        name: "",
        data: {},
        isPreEvent: function () {
            switch (this.type) {
                case 'message':
                    return true;
                    break;
                case 'jump':
                    return false;
                case 'load':
                case 'exit':
                    return false;
                case 'shop':
                    return true;
                case 'hotel':
                    return true;
                case 'npc':
                    if (this.pre.length) {
                        var flag = world.flag;
                        eval("res =" + this.pre[0]);
                        return res;
                    } else {
                        return true;
                    }
                case 'box':
                    return true;
                case 'item':
                    return true;
                case 'door':
                    return true;
                case 'wall':
                    return true;
                case 'roof':
                    return false;
                case 'flag':
                    return false;
                case 'secret':
                    return false;
                case 'chip':
                    return false;
                case 'start':
                    return true;
            }
            return true;
        },
        fire: function (world, callback) {
            var sc = world.screen;
            switch (this.type) {
                case 'message':
                    this._showMessage(world.screen);
                    return true;
                    break;
                case 'jump':
                    this._showMessage(world.screen);
                    world.map.move(this.data.to[0] - DQ.OX, this.data.to[1] - 7);
                    return true;
                case 'load':
                    this._load(sc, callback);
                case 'exit':
                    this._exit(sc, callback);
                    return true;
                case 'shop':
                    this._shop(sc, callback);
                    return true;
                case 'hotel':
                    this._hotel(sc, callback);
                    return true;
                case 'npc':
                    this._npc(sc, this.name);
                    return true;
                case 'box':
                    this._openBox(sc, callback);
                    return true;
                case 'secret':
                    this._searchAt(sc, callback);
                    return true;
                case 'door':
                    return this._openDoor(sc, callback);
                case 'item':
                    return this._getItem(sc, callback);
                case 'wall':
                    return true;
                case 'roof':
                    return false;
                case 'chip':
                    return this._fireEvent(sc, callback);
                case 'flag':
                case 'enter':
                    return this._fireEvent(sc, callback);
                case 'start':
                    return this._startEvent(sc, callback);
            }
        },
        _npc: function (sc, name) {
            var npc = world.map.getNPC();
            for (var i = 0; i < npc.length; i++) {
                if (this.position[0] == npc[i].pos[0] + world.map.mapX &&
                    this.position[1] == npc[i].pos[1] + world.map.mapY) {
                    switch (world.chara.dir) {
                        case DQ.DIR.LEFT:
                            npc[i].stamp(DQ.DIR.RIGHT, true);
                            break;
                        case DQ.DIR.RIGHT:
                            npc[i].stamp(DQ.DIR.LEFT, true);
                            break;
                        case DQ.DIR.UP:
                            npc[i].stamp(DQ.DIR.DOWN, true);
                            break;
                        case DQ.DIR.DOWN:
                            npc[i].stamp(DQ.DIR.UP, true);
                            break;
                    }
                    break;
                }
            }
            var flag = world.flag,
                me = this; ;
            if (this.data.battle) {
                world.startBattle({ enemy: this.data.enemy, callback: function (win) {
                    if (win) {
                        me.post[0] && eval(me.post[0]);
                    }
                }
                });
            } else if (this.data.command) {
                eval(this.command);
            } else {

                this._showMessage(sc, this.name);
                var flag = world.flag;
                this.post[0] && eval(this.post[0]);
            }

        },
        _fireEvent: function (sc, callback) {
            ///<summary>
            /// スクリプトの実行だけをする
            ///</summary>

            var flag = world.flag;
            this.post[0] && eval(this.post[0]);
        },
        _startEvent: function (sc) {
            var show = false,
                flag = world.flag;

            if (this.message.length == 0) {
                debug.writeln("error: DQ.Event._startEvent: data error. message nothing.");
            }

            this.conditions[0] && eval('show =' + this.conditions[0]);
            var player = world.party[0];
            if (!show) {
                return false;
            }
            eval(this.post[0]);
            if (this.data.to) {
                world.map.move(this.data.to[0] - DQ.OX, this.data.to[1] - DQ.OY);
            }
            if (this.data && this.data.dir) {
                world.chara.wark(this.data.dir, true);
            }
            var _msg = null, msg;
            if (typeof this.message[0] == "number") {
                _msg = world.messages.find('uid', this.message[0]);
                if (!_msg) {
                    debug.writeln(DQ.format("error: message not found in _startEvent[{0}]", this.message[0]));
                }
            }
            msg = _msg && _msg.message || this.message;
            if (this.name) {
                sc.showMessage(msg[0], this.name);
            } else {
                sc.showMessage(msg[0]);
            }

            return true;
        },
        _getItem: function (sc, callback) {
            var valid = false;
            flag = world.flag;
            this.conditions[0] && eval('valid =' + this.conditions[0]);
            if (!valid) {
                return false;
            }
            if (valid) {
                var player = world.party[0];
                var msg = [];
                var result = world.getItem(player, this.data, msg);
                sc.showMessage(msg, callback);
                result && eval(this.post[0]);
                world.map.layer[0].forceMap();
            }
            return true;
        },
        _openDoor: function (sc, callback) {
            var door = false;
            flag = world.flag;
            this.conditions[0] && eval('door =' + this.conditions[0]);
            if (!door) {
                return false;
            }
            if (this.data.key == 0) {
                eval(this.post[0]);
                sc.showMessage(DQ.format("とびらを開きました"), callback);
                world.map.layer[0].forceMap();
            } else if (world.party.any("hasItem", this.data.key)) {
                for (var i = 0; i < world.party.length; i++) {
                    var player = world.party[i];
                    if (player.hasItem(this.data.key)) {
                        player.useItem(this.data.key);
                        break;
                    }
                }
                eval(this.post[0]);
                sc.showMessage(DQ.format("とびらを開きました"), callback);
                world.map.layer[0].forceMap();
            } else {
                sc.showMessage(DQ.format("カギを　持っていない！"), callback);
            }

            return true;
        },
        _openBox: function (sc, callback) {
            var valid = false;
            flag = world.flag;
            this.conditions[0] && eval('valid =' + this.conditions[0]);
            if (valid) {
                var player = world.party[0];
                var msg = [];
                var result = world.openBox(player, this.data, msg);
                sc.showMessage(msg, callback);
                result && eval(this.post[0]);
                world.map.layer[0].forceMap();
            } else {
                sc.showMessage(["宝箱を調べた。", "宝箱は空だった。"], callback);
            }

            return false;
        },
        _searchAt: function (sc, callback) {
            var valid = false;
            flag = world.flag;
            sc._msgBox.name("");
            this.conditions[0] && eval('valid =' + this.conditions[0]);
            if (valid) {
                var player = world.party[0];
                var msg = [];
                var result = world.searchAt(player, this.data, msg);
                sc.showMessage(msg, callback);
                result && eval(this.post[0]);
                world.map.layer[0].forceMap();
            } else {
                sc.showMessage(["自分の足元を調べた。", "しかし何も見つからなかった。"], callback);
            }

            return false;
        },
        _showMessage: function (sc, name, callback) {
            DQ.stop();
            var flag = world.flag;
            var pos = 0;
            this.conditions[0] && eval('pos =' + this.conditions[0]);

            var _msg = null, msg;
            if (typeof this.message[0] == "number") {
                _msg = world.messages.find('uid', this.message[0]);
                if (!_msg) {
                    debug.writeln(DQ.format("error: message not found in _showMessage[{0}]", this.message[0]));
                }
            }
            msg = _msg && _msg.message || this.message;
            if (name) {
                sc.showMessage(msg[pos], name, function () { callback && callback(); DQ.start(); });
            } else {
                sc.showMessage(msg[pos], function () { callback && callback(); DQ.start(); });
            }
        },
        loading: false,
        _load: function (sc) {
            var jingle = world.sounds.find('name', 'step');
            var me = this;
            if (jingle) {
                world.playJingle2(jingle.src, false, function () { }, function () {
                    world.jump(me.name, me.data.to[0] - DQ.OX, me.data.to[1] - DQ.OY);
                });
            } else {
                world.jump(me.name, me.data.to[0] - DQ.OX, me.data.to[1] - DQ.OY);
            }
        },
        _exit: function (sc) {
            var jingle = world.sounds.find('name', 'step');
            var me = this,
                flag = world.flag;
            if (jingle) {
                world.playJingle2(jingle.src, false, function () { }, function () {
                    world.jump(me.name, me.data.to[0] - DQ.OX, me.data.to[1] - DQ.OY);
                });
            } else {
                world.jump(me.name, me.data.to[0] - DQ.OX, me.data.to[1] - DQ.OY);
            }
            this.post[0] && eval(this.post[0]);
        },
        _shop: function (sc, callback) {
            world.shop.setup(world.party, world.shops.catalog[this.data.uid], callback);
        },
        _hotel: function (sc, callback) {
            world.hotel.setup(world.party, world.shops.catalog[this.data.uid], callback);
        }
    }

    DQ.EventCatalog = function (options) {
        /// <summary>
        ///     イベント構造を保持します。
        /// </sumamry>
        /// <param name="world" type="DQ.World">
        ///     ゲーム情報を保持する DQ.Worldのインスタンスを指定
        /// </param>
        /// <param name="options" type="object">
        ///     イベント管理へのオプションを指定
        /// </param>

        this.world = world;
        this.map = world.map;
        this.screen = world.screen;

        options = DQ.options(options, { url: "data/event.txt", callback: null });
        this.url = options.url;
        this.onLoaded = options.callback;
        this.load(this.url);
    }

    DQ.EventCatalog.prototype = {
        world: null,
        map: null,
        screen: null,
        onLoaded: function () { },
        events: [],
        encounts: [],
        start: null,
        exit: null,
        enter: null,
        catalog: [],
        npcs: [],
        load: function (url) {
            /// <summary>
            /// イベントデータをサーバーから取得します。
            /// </summary>
            var me = this;
            this.catalog = [];
            DQ.loadCatalog(url, function (data) {
                try {
                    eval('var s=' + data);
                } catch (ex) {
                    alert(DQ.format("DQ.EventCatalog.load::カタログに文法エラー発生:{0}", ex.Message));
                    me.onLoaded && me.onLoaded(me, false);
                }
                for (var i = 0; i < s.catalog.length; i++) {
                    me.catalog[s.catalog[i].map] = s.catalog[i];
                }
                me.onLoaded && me.onLoaded(me, true);
            });
        },
        setup: function (name) {
            /// <summary>
            /// マップに対応するイベントを設定します。
            /// </summary>
            /// <param name="name" type="number/string">
            /// uidもしくはマップ名を指定
            /// </param>
            var se = null;
            if (typeof name == "number") {
                for (var nm in this.catalog) {
                    if (this.catalog[nm].uid == name) {
                        se = this.catalog[nm].events;
                        this.map = this.catalog[nm].map;
                        break;
                    }
                }
            } else if (this.catalog[name]) {
                se = this.catalog[name].events;
                this.map = name;
            }
            var e = this.events = [];
            var en = this.encounts = [];
            this.exit = null;
            this.start = null;
            this.sound = null;
            this.enter = null;
            this.npcs = [];
            if (se == null) {
                throw new Error("指定のマップに対応するイベントカタログが存在しません[" + name + "]");
            }
            for (var i = 0; i < se.length; i++) {
                if (se[i].type == "encount") {
                    en.push(new DQ.Event(se[i]));
                } else if (se[i].type == "exit") {
                    this.exit = new DQ.Event(se[i]);
                } else if (se[i].type == "sound") {
                    this.sound = new DQ.Event(se[i]);
                } else if (se[i].type == "start") {
                    this.start = new DQ.Event(se[i]);
                } else if (se[i].type == "enter") {
                    this.enter = new DQ.Event(se[i]);
                } else if (se[i].type == "npc") {
                    this.npcs.push(new DQ.Event(se[i]));
                } else if (se[i].type == "chip") {
                    var chip = new DQ.Event(se[i]);
                    this.chips = this.chips || [];
                    this.chips[chip.data.no] = chip;
                } else {
                    if (!e[se[i].position.toString()]) {
                        e[se[i].position.toString()] = [];
                    }
                    e[se[i].position.toString()].push(new DQ.Event(se[i]));
                }
            }

        },
        playSound: function () {
            if (this.sound) {
                var sound = world.sounds.find("name", this.sound.name);
                sound && world.playSound(sound.src);
            }
        },
        isPreEvent: function (pos) {
            var result = false;
            var e = this.events[pos];
            if (e) {
                for (var i = 0; i < e.length; i++) {
                    result |= e[i].isPreEvent();
                }
            }
            for (var i = 0; i < this.npcs.length; i++) {
                var d = this.npcs[i];
                if (d.position[0] == pos[0] && d.position[1] == pos[1]) {
                    result |= d.isPreEvent();
                }
            }
            return result;
        },
        fire: function (pos, callback) {
            var result = false;
            var e = this.events[pos];
            if (e) {
                for (var i = 0; i < e.length; i++) {
                    if (e[i].type != "secret") {
                        result |= e[i].fire(this.world, callback);
                    }
                }
            }

            for (var i = 0; i < this.npcs.length; i++) {
                var d = this.npcs[i];
                if (d.position[0] == pos[0] && d.position[1] == pos[1]) {
                    if (d.isPreEvent()) {
                        result |= d.fire(this.world, callback);
                    }
                }
            }
            //チップに設定されたイベント(沼など)
            var c = world.map.data[pos[1]][pos[0]];
            if (this.chips && this.chips[c]) {
                result |= this.chips[c].fire(this.world, callback);
            }
            return result;
        },
        searchAt: function (pos, callback) {
            ///<summary>
            ///  足元を調べる
            ///</summary>

            var result = false;
            var e = this.events[pos];
            if (e) {
                for (var i = 0; i < e.length; i++) {
                    if (e[i].type == "secret") {
                        result |= e[i].fire(this.world, callback);
                    }
                }
            }
            if (!result) {
                world.screen.showMessage(["$name は、足元を調べた。", "しかし、何も見つからなかった。"]);
            }
            return result;
        }
    }
    DQ.Event.AI = { None: 0, Stamp: 1, TopDown: 2, LeftRight: 3, Wark: 4 }
    DQ.Event.NPC = dqextend(DQ.Event, function (options) {
        this.base(options);

        var npc_options = DQ.options(options.data, {
            dir: 0,
            AI: DQ.Event.AI.Stamp
        });
    },
    {
        dir: 0,
        AI: DQ.Event.AI.Stamp,
        update: function () {
        }
    });
});