﻿/// <reference path="../jquery.js" />
/// <reference path="../dq.js" />
/// <reference path="../dq-core.js" />
/// <reference path="../ui/dq-ui.js" />
/// <reference path="dq-rpg.js" />
/// <reference path="dq-rpg-magic.js" />

/*
* DQ Retro game UI framework JavaScript library version v0.6.0
*
* Copyright (c) 2009-2010 M., Koji
* Licensed under the MIT License: http://www.opensource.org/licenses/mit-license.php
*
* Date: 2010-04-01 17:34:21 -0900
* Revision: 0004
*/
DQ.lazyLoad(DQ.subdir + "rpg/dq-rpg.js", "DQ.RPG.InputBox", function () {
    DQ.RPG.EquipmentBox = dqextend(DQ.Control, function (parent, options) {

        options = options || {};
        this.onEquip = options.equip;

        this.base(parent, $('<div>').css('z-index', 999));
        this._group = new DQ.StateGroup(parent, [
            { name: 'who', options: {
                left: '1em',
                top: '3em',
                width: '8em',
                canSelect: true, text: _("Equipment")
            }
            },
            { name: 'eqp', options: {
                left: '9em',
                top: '3em',
                width: '12em',
                height: '7em',
                canSelect: false,
                showName: true,
                cancelNotHide: true,
                text: "げんざいのそうび"
            }
            },
            { name: 'what', options: {
                left: '9em',
                top: '12em',
                width: '6em',
                canSelect: true,
                showName: false,
                cancelNotHide: true
            }
            },
            { name: 'to', options: {
                left: '21em',
                top: '3em',
                width: '8em',
                height: '10em',
                canSelect: true,
                cancelNotHide: true
            }
            },
            { name: 'change', options: {
                left: '9em',
                top: '19em',
                width: '20em',
                height: '5em',
                showName: true,
                text: _("Description")
            }
            }]);

        this._create(options);
    },
    {
        onEquip: null,
        _create: function (options) {
            var _player = null,
                _equip = null,
                _listType = null,
                _uid = -1,
                _serial = 0,
                _eqp = 0,
                me = this,
            party_toString = function (party) {
                var data = [];
                for (var i = 0; i < party.length; i++) {
                    data.push({ text: party[i].name });
                }
                return data;
            },
            _getEqpList = function (group, pos) {
                var types = ["weapon", "armor", "shield", "accesary"],
                eq = [],
                eqps = _equip = world.items.choose(_player, types[pos]);

                _listType = types[pos];

                for (var i = 0; i < eqps.length; i++) {
                    eq.push({
                        text: ['<span class="dq-exp-mark">', eqps[i].equip ? "E" : "&nbsp;",
                            '</span><span class="dq-eqp-value">',
                            world.items.catalog[eqps[i].uid].name, '</span>'].join(''),
                        item: eqps[i]
                    });
                }
                eq.push({ text: '<span class="dq-exp-mark">&nbsp;</span><span class="dq-eqp-value">-はずす-</span>' });

                return eq;
            },
            _setupInfo = function (sender, pos) {
                var orgA = _player.getAttack(),
                    orgD = _player.getDefence(),
                    nxtA,
                    nxtD,
                    desc,
                    back;
                if (pos >= _equip.length) {
                    sender.text("はずす");
                    desc = "装備をはずします。";
                    _uid = -1;
                    _serial = -1;
                } else {
                    _uid = _equip[pos].uid;
                    _serial = _equip[pos].serial;
                    desc = world.items.catalog[_uid].description;
                    sender.text(world.items.catalog[_uid].name);
                }
                switch (_listType) {
                    case 'weapon':
                        back = _player.equipmentIDs().weapon.uid;
                        _player.equipmentIDs().weapon.uid = _uid;
                        break;
                    case 'armor':
                        back = _player.equipmentIDs().armor.uid;
                        _player.equipmentIDs().armor.uid = _uid;
                        break;
                    case 'shield':
                        back = _player.equipmentIDs().shield.uid;
                        _player.equipmentIDs().shield.uid = _uid;
                        break;
                    case 'accesary':
                        back = _player.equipmentIDs().accesary.uid;
                        _player.equipmentIDs().accesary.uid = _uid;
                        break;
                }
                nxtA = _player.getAttack();
                nxtD = _player.getDefence();
                switch (_listType) {
                    case 'weapon':
                        _player.equipmentIDs().weapon.uid = back;
                        break;
                    case 'armor':
                        _player.equipmentIDs().armor.uid = back;
                        break;
                    case 'shield':
                        _player.equipmentIDs().shield.uid = back;
                        break;
                    case 'accesary':
                        _player.equipmentIDs().accesary.uid = back;
                        break;
                }
                sender.setData([
                    { 'text': ['<span class="dq-st-nm">ATK:</span><span>', orgA, '</span>', '<span>→</span>', '<span>', nxtA, '</span>'].join('') },
                    { 'text': ['<span class="dq-st-nm">DEF:</span><span>', orgD, '</span>', '<span>→</span>', '<span>', nxtD, '</span>'].join('') },
                    { 'text': ['<div>', desc, '</div>'].join('') }
                    ]);
            },
            getCurrent = function (player) {
                var eq = [],
                    eqps = _player.getEquipmentString();
                eq.push({ 'text': ['<span class="dq-icon dq-icon-wep">&nbsp;</span><span class="dq-exp-label">' + _('Weapon') + '：</span><span class="dq-eqp-value">', eqps[2], '</span>'].join('') });
                eq.push({ 'text': ['<span class="dq-icon dq-icon-wep">&nbsp;</span><span class="dq-exp-label">' + _('Armor') + '：</span><span class="dq-eqp-value">', eqps[1], '</span>'].join('') });
                eq.push({ 'text': ['<span class="dq-icon dq-icon-wep">&nbsp;</span><span class="dq-exp-label">' + _('Shield') + '：</span><span class="dq-eqp-value">', eqps[5], '</span>'].join('') });
                eq.push({ 'text': ['<span class="dq-icon dq-icon-wep">&nbsp;</span><span class="dq-exp-label">' + _('Accesary') + '：</span><span class="dq-eqp-value">', eqps[6], '</span>'].join('') });
                return eq;
            };

            //だれ
            this._group.who.setData(party_toString(world.party));
            if (options.parentMenu) {
                options.parentMenu.setSubItem(this._group.who);
            }

            //装備選択肢
            this._group.what.setData([{ text: _("Weapon") }, { text: _("Armor") }, { text: _("Shield") }, { text: _("Accesary")}]);

            this._group.onVisibleChanged = function (group, sender, visible) {
                if (!visible && sender.name == "who") {
                    me.hide();
                }
                if (!visible && sender.name == "what") {
                    group.focus("who");
                }
                if (!visible && sender.name == "to") {
                    group.focus("what");
                }
            }
            this._group.onClick = function (group, sender) {
                if (sender.name == "who") {
                    group.what.enabled(true);
                    group.what.selected(0);
                    group.focus("what");
                } else if (sender.name == "to") {
                    me.onEquip && me.onEquip(_player, { type: _listType, uid: _uid, serial: _serial });
                    group.eqp.setData(getCurrent());
                    var icons = $('.dq-icon', group.eqp.obj);
                    $(icons[0]).css('background', DQ.RPG.Icon.getBackground(1, 0));
                    $(icons[1]).css('background', DQ.RPG.Icon.getBackground(0, 13));
                    $(icons[2]).css('background', DQ.RPG.Icon.getBackground(0, 12));
                    $(icons[3]).css('background', DQ.RPG.Icon.getBackground(0, 20));

                    group.to.setData(_getEqpList(group, _eqp));
                    group.to.selected(-1);
                    group.focus("what");
                }
                else if (sender.name == "what") {
                    group.to.enabled(true);
                    group.focus("to");
                    group.to.selected(0);
                }
            }

            this._group.onSelectedIndexChanged = function (group, sender, pos) {
                if (sender.name == "who") {
                    _player = world.party[pos];
                    group.eqp.setData(getCurrent(_player));
                    var icons = $('.dq-icon', group.eqp.obj);
                    $(icons[0]).css('background', DQ.RPG.Icon.getBackground(1, 0));
                    $(icons[1]).css('background', DQ.RPG.Icon.getBackground(0, 13));
                    $(icons[2]).css('background', DQ.RPG.Icon.getBackground(0, 12));
                    $(icons[3]).css('background', DQ.RPG.Icon.getBackground(0, 20));
                } else if (sender.name == "what") {
                    _eqp = pos;
                    group.to.setData(_getEqpList(group, _eqp));
                    group.to.selected(-1);
                } else if (sender.name == "to") {
                    _setupInfo(group.change, pos);
                }
            }
            this._group.onLeave = function (group, sender) {
            }
        },
        player: null,
        setup: function (player) {
            player = (player instanceof DQ.RPG.Creature) ? player : this.player;
            this.player = player;

            var eq = [];
            var eqps = player.getEquipmentString();
            eq.push({ 'text': ['<span class="dq-exp-label">' + _('Weapon') + '：</span><span class="dq-exp-value">', eqps[2], '</span>'].join('') });
            eq.push({ 'text': ['<span class="dq-exp-label">' + _('Armor') + '：</span><span class="dq-exp-value">', eqps[1], '</span>'].join('') });
            eq.push({ 'text': ['<span class="dq-exp-label">' + _('shield') + '：</span><span class="dq-exp-value">', eqps[5], '</span>'].join('') });
            eq.push({ 'text': ['<span class="dq-exp-label">' + _('accesary') + '：</span><span class="dq-exp-value">', eqps[5], '</span>'].join('') });

            this.eqpBox.setData(eq);
        },
        show: function () {
            __dqsuper__(this, "show", arguments);

            this._group.to.enabled(false);
            this._group.what.enabled(false);
            this._group.who.show();
            this._group.eqp.show();
            this._group.what.show();
            this._group.to.show();
            this._group.change.show();

            this.onVisibleChanged && this.onVisibleChanged(this, true);
            this._group.focus("who");
        },
        onVisibleChanged: null,
        hide: function () {
            if (!this._visible) {
                return;
            }
            __dqsuper__(this, "hide", arguments);
            this._group && this._group.hide();
            this.onVisibleChanged && this.onVisibleChanged(this, false);
        }
    }, {
    });

    DQ.RPG.MagicBox = dqextend(DQ.Control, function (screen, options) {
        /// <summary>
        /// 魔法選択ボックスを作成します。
        /// </summary>

        options = DQ.options(options, {
            showName: false,
            canSelect: true,
            top: DQ.T1,
            player: null
        });

        this.player = options.player;
        this.onChant = options.chant;
        this.base(screen, $('<div>').css('z-index', 999));

        this._group = new DQ.StateGroup(screen, [
            { name: 'who', options: {
                left: '2em',
                top: '2em',
                width: '8em',
                canSelect: true,
                text: _("Spell")
            }
            },
            {
                name: 'to', options: {
                    width: '6em',
                    height: 'auto',
                    left: DQ.L1,
                    top: DQ.T3,
                    canSelect: true,
                    text: _("To")
                }
            },
            {
                name: "magic", options: {
                    cls: 'dq-mp-box',
                    left: '10em',
                    top: '2em',
                    width: '7em',
                    height: '10em',
                    canSelect: true,
                    cancelNotHide: true
                }
            },
            {
                name: "desc", options: {
                    cls: 'dq-mpdesc',
                    width: '12em',
                    height: '4em',
                    left: '17em',
                    top: '2em',
                    autoClose: false,
                    autoScroll: false,
                    canSelect: false,
                    speed: 0
                }
            },
            {
                name: "mp", options: {
                    width: '7em',
                    height: '2em',
                    cls: 'dq-mp-box',
                    left: DQ.L4,
                    top: '8em',
                    showName: false,
                    canSelect: false,
                    text: _("消費ＭＰ")
                }
            }]);

        var me = this,
            _pos,
            _mgc,
            _player,
            _pPos,
            _to,
            party_toString = function (party, onlyLive) {
                var data = [];
                for (var i = 0; i < party.length; i++) {
                    data.push({ text: party[i].name, enabled: (!onlyLive || !party[i].isDead()) });
                }
                return data;
            },
            getCurrent = function (player) {
                var mg = [];
                for (var i = 0; i < player.magicIDs.length; i++) {
                    if (world.magics.catalog[player.magicIDs[i]].category == DQ.RPG.Magic.Category.Attack) {
                        continue;
                    }
                    mg.push({
                        'text': world.magics.catalog[player.magicIDs[i]].text,
                        'orgPos': i
                    });
                }
                return mg;
            };

        //だれ
        this._group.who.setData(party_toString(world.party, true));
        if (options.parentMenu) {
            options.parentMenu.setSubItem(this._group.who);
        }

        this._group.onSelectedIndexChanged = function (group, sender, pos) {
            _pos = pos;
            if (sender.name == "who") {
                _player = world.party[pos];
                var mp = getCurrent(_player);
                if (!mp.length) {
                    //world.screen.showMessage(this.player.name + " は 呪文を使えない。", function () {
                    //  me.hide();
                    //}
                }
                group.magic.setData(mp);

            } else if (sender.name == "to") {
                _to = world.party[pos];
            } else if (sender.name == "magic") {
                group.focus("magic");
                _mgc = pos;
                var id = _player.magicIDs[sender.data[pos].orgPos],
                    magic = world.magics.catalog[id];

                group.desc.setData([{ text: magic.description}]);
                group.mp.setData([{
                    text: ['<div class="dq-mbox-mp">', magic.MP, "／", _player.mp(), '</div>'].join('')
                }]);
            }

        }
        this._group.onVisibleChanged = function (group, sender, state) {
            if (!state && sender.name == "who") {
                group.hide();
            } else if (!state && sender.name == "magic") {
                group.focus("who");
            } else if (state && sender.name == "magic") {
                group.focus("magic");
            }
        }
        this._group.onClick = function _group_onClick(group, sender) {
            /// <summary>
            ///   　魔法を使用する
            /// </summary> 
            if (sender.name == "who") {
                group.magic.enabled(true); //見え消し状態を有効にすると,hide()相当ではenabled()==falseになっている。
                group.focus("magic");
            } else if (sender.name == "magic") {
                var pPos = _pPos = sender.data[_mgc].orgPos,
                    hide = false,
                    id = _player.magicIDs[pPos],
                    magic = world.magics.catalog[id];
                group.unfocus("magic");
                if (magic.uid == 10007) { //ここに埋め込むのは回避したかった・・・
                    group.to.text(_("Which"));
                    var town = world.getVisitedTown();
                    if (town.length == 0) {
                        world.screen.showMessage("帰るべき町はない。", "");
                        return;
                    }
                    group.to.setData(town);
                    group.to.show();
                    group.to.focus();
                } else if (magic.type != "party") {
                    if (world.party.length == 1) {
                        hide = me.onChant ? me.onChant(me, _player, _player, _player.magicIDs[_pPos], _pPos) : true;
                    } else {
                        group.to.text(_("To"));
                        group.to.setData(party_toString(world.party, false));
                        group.to.show();
                        group.to.focus();
                    }
                } else {
                    if (world.magics.catalog[id].category == DQ.RPG.Magic.Category.Attack) {
                        hide = me.onChant ? me.onChant(me, _player, null, player.magicIDs[_pPos], _pPos) : true;
                    } else {
                        hide = me.onChant ? me.onChant(me, _player, _player, _player.magicIDs[_pPos], _pPos) : true;
                    }
                    hide && me.hide();
                }
            } else if (sender.name == "to") {
                var hide = false,
                    id = _player.magicIDs[_pPos],
                    magic = world.magics.catalog[id],
                    index = sender.selectedIndex();

                group.focus("who");
                sender.hide();
                if (magic.uid == 10007) {
                    hide = me.onChant ? me.onChant(me, _player, {
                        name: "map", //group.to.data[index].name,
                        x: group.to.data[index].value[0],
                        y: group.to.data[index].value[1]
                    },
                        _player.magicIDs[_pPos], _pPos) : true;
                } else if (world.magics.catalog[id].category == DQ.RPG.Magic.Category.Attack) {
                    hide = me.onChant ? me.onChant(me, _player, null, player.magicIDs[_pPos], _pPos) : true;
                } else {
                    hide = me.onChant ? me.onChant(me, _player, _to, _player.magicIDs[_pPos], _pPos) : true;
                }
                hide && me.hide();
            }
        };
        this._group.onLeave = function (group, sender) {
        }

    }, {
        dqid: "DQ.RPG.MagicBox",
        onChant: null,
        setup: function (player) {
            player = (player instanceof DQ.RPG.Creature) ? player : this.player;
            this.player = player;

            var mg = [];
            for (var i = 0; i < player.magicIDs.length; i++) {
                mg.push({
                    'text': world.magics.catalog[player.magicIDs[i]].text,
                    'orgPos': i
                });
            }
            if (mg.length == 0) {
                return false;
            }
            this._group.magic.setData(mg);

            return true;
        },
        show: function (player) {
            __dqsuper__(this, "show", arguments);

            this._group.who.show();
            this._group.magic.show();
            this._group.desc.show();
            this._group.mp.show();
            this._group.magic.enabled(false);

            this._group.who.select();
            this.onVisibleChanged && this.onVisibleChanged(this, true);
            this._group.focus("who");
        },
        hide: function () {
            if (!this._visible) {
                return;
            }
            __dqsuper__(this, "hide", arguments);
            this._group && this._group.hide();
            this.onVisibleChanged && this.onVisibleChanged(this, false);
        }
    },
        {});

    DQ.RPG.ItemBox = dqextend(DQ.Control, function (screen, options) {
        options = DQ.options(options, {
            cls: "dq-item",
            player: null,
            disableNotUse: true
        });
        this.onUse = options.use;
        this.player = options.player;
        this.disableNotUse = options.disableNotUse;

        this.base(screen, $('<div>'));
        this.visible(false);

        this._create(screen, options);
    }, {
        onUse: null,
        _create: function (screen, options) {
            this._group = new DQ.StateGroup(screen, [
                {
                    name: 'who', options: {
                        left: '1em',
                        top: '2em',
                        width: '8em',
                        canSelect: true,
                        text: _("Item")
                    }
                },
                {
                    name: "item", options: {
                        cls: 'dq-item',
                        left: '10em',
                        top: '2em',
                        width: '14em',
                        height: '10em',
                        row: 10,
                        canSelect: true,
                        cancelNotHide: true
                    }
                },
                {
                    name: "cmd", options: {
                        width: '6em', height: 'auto',
                        left: DQ.L1,
                        top: '8em', showName: false, canSelect: true,
                        text: _("Action"),
                        data: [
                            { text: _("Use") },
                            { text: _("Trade") },
                            { text: _("Drop")}]
                    }
                },
                {
                    name: 'to', options: {
                        width: '6em', height: 'auto',
                        left: DQ.L1,
                        top: '11em',
                        showName: false, canSelect: true,
                        text: _("To")
                    }
                },
                {
                    name: "yesno", type: "YesNo", options: {
                        left: DQ.L2, top: DQ.T2
                    }
                }
            ]);

            var me = this,
                _item, _command, _pos, _itemPos, _player,
                _to,
            party_toString = function (party) {
                var data = [];
                for (var i = 0; i < party.length; i++) {
                    data.push({ text: party[i].name });
                }
                return data;
            },
            getCurrent = function (player, showAll) {
                var it = [], names = ["つかうもの", "だいじなもの"];
                var ct = world.items.catalog;
                for (var i = 0; i < player.items.length; i++) {
                    var itemInfo = player.items[i],
                    item = ct[itemInfo.uid];

                    if (item && (item.category == names[0] || showAll && item.category == names[1])) {
                        it.push({
                            text: ['<span class="name">', item.text, '</span><span class="count">', itemInfo.count, '</span>'].join(''),
                            orgPos: i
                        });
                    }
                }

                return it;
            }

            //だれ
            this._group.who.setData(party_toString(world.party));
            if (options.parentMenu) {
                options.parentMenu.setSubItem(this._group.who);
            }

            this._group.onVisibleChanged = function (group, sender, visible) {
                if (!visible && sender.name == "who") {
                    me.hide();
                } else if (!visible && sender.name == "item") {
                    group.focus("who");
                } else if (!visible && sender.name == "cmd") {
                    if (group.item.menuItems.length > 0) {
                        group.focus("item");
                    } else {
                        group.item.enabled(false);
                        group.focus("who");
                    }
                } else if (!visible && sender.name == "to") {
                    group.focus("cmd");
                }
            }
            this._group.onSelectedIndexChanged = function (group, sender, pos) {
                _pos = pos;
                if (sender.name == "who") {
                    _player = world.party[pos];
                    group.item.setData(getCurrent(_player, true));
                    for (var i = 0; i < group.to.menuItems.length; i++) {
                        group.to.menuItems[i].enabled(true);
                    }
                    group.to.menuItems[pos].enabled(false);
                } else if (sender.name == "to") {
                    _to = world.party[pos];
                } else if (sender.name == "item") {
                    group.focus("item");
                    _to = world.party[pos];
                }
            }
            this._group.onClick = function (group, sender) {
                if (sender.name == "who") {
                    if (group.item.menuItems.length > 0) {
                        group.item.enabled(true); //見え消し状態を有効にすると,hide()相当ではenabled()==falseになっている。
                        group.focus("item");
                    }
                } else if (sender.name == "to") {
                    var hide = false,
                        to = world.party[sender.selectedIndex()];
                    group.unfocus("to");
                    switch (_command) {
                        case 0:
                            hide = me.onUse && me.onUse(me.player, to, _item, _itemPos) || true;
                            break;
                        case 1:
                            hide = me.onTrade && me.onTrade(_player, to, _item, _itemPos) || true;
                            me.update();
                            break;
                    }
                    group.item.setData(getCurrent(_player, true));
                    group.to.hide();
                    group.cmd.hide();
                    group.focus("item");
                } else if (sender.name == "item") {
                    _item = _player.items[group.item.data[sender.selectedIndex()].orgPos];
                    _itemPos = sender.selectedIndex();
                    group.cmd.show(true);
                    group.cmd.menuItems[1].enabled(world.party.length > 1);
                    group.focus("cmd");
                } else if (sender.name == "cmd") {
                    _command = sender.selectedIndex();
                    var item = world.items.catalog[_item.uid];
                    switch (_command) {
                        case 0:
                            var hide = false;
                            if (world.party.length > 1 && item.type != "event" && item.type != "field" && item.type != "party" && item.type != "jump") {
                                group.to.show(true);
                                group.focus("to");
                            } else {
                                hide = me.onUse ? me.onUse(me.player, me.player, _item, _itemPos) : true;
                            }
                            hide && me.hide();
                            break;
                        case 1:
                            group.to.show();
                            group.focus("to");
                            break;
                        case 2:
                            if (item.type == "event") {
                                group.unfocus("cmd");
                                world.showMessage(["大事なものを捨てることはできない。"], function () { sender.hide(); });
                                break;
                            }
                            group.yesno.text("捨てる？");
                            group.yesno.show();
                            break;
                    }
                } else if (sender.name == "yesno") {
                    //今のところDropだけなので
                    me.player.dropItem(_item.uid, _item.count);
                    var it = getCurrent(_player, true);
                    group.item.setData(it);
                    if (it.length) {
                        world.showMessage([[world.party[0].name, "は、どうぐを持っていない。"].join('')], function () {
                            me.hide();
                        });
                    }
                    group.cmd.hide();
                }
            }
            this._group.onLeave = function (group, sender) {
                if (sender.name == "item" && !sender.enabled()) {
                    //group.focus("who");
                }
            }
        },
        player: null,
        disableNotUse: false,
        setup: function (player) {
            player = (player instanceof DQ.RPG.Creature) ? player : world.party[0];
            this.player = player;

            var it = [],
                names = ["つかうもの", "だいじなもの"],
                ct = world.items.catalog,
                i;


            for (i = 0; i < player.items.length; i++) {
                var itemInfo = player.items[i],
                    item = ct[itemInfo.uid];

                if (item) {
                    it.push({
                        text: ['<span class="name">', item.text, '</span><span class="count">', itemInfo.count, '</span>'].join(''),
                        orgPos: i,
                        enabled: item.canUse()
                    });
                }
            }
            if (it.length == 0) {
                return false;
            }
            this._group.item.setData(it);
            var member = [];
            for (i = 0; i < world.party.length; i++) {
                member.push({ text: world.party[i].name, enabled: world.party[i] != this.player });
            }
            this._group.to.setData(member);

            //交換はパーティーが複数の時だけ
            this._group.cmd.menuItems[1].enabled(world.party.length > 1);

            return true;
        },
        show: function (player) {
            __dqsuper__(this, "show", arguments);

            this.setup(player);

            this._group.item.enabled(false);
            this._group.who.show();
            this._group.focus("who");
            this._group.item.show();
            this._group.cmd.hide();
            this._group.to.hide();

            this._group.who.select();
            this.onVisibleChanged && this.onVisibleChanged(this, true);
            this._group.focus("who");
        },
        hide: function () {
            if (!this._visible) {
                return;
            }
            __dqsuper__(this, "hide", arguments);
            this._group && this._group.hide();
            this.onVisibleChanged && this.onVisibleChanged(this, false);
        },
        update: function () {
            this.setup();
        }
    });

    DQ.RPG.StatusBox = dqextend(DQ.Control, function (parent, options) {

        options = options || {};

        this.base(parent, $('<div>').css('z-index', 999));
        this.visible(false);

        this._group = new DQ.StateGroup(parent, [
            { name: 'who', options: {
                left: '1em',
                top: '4em',
                width: '7em',
                canSelect: true,
                text: _("STATUS")
            }
            },
            { name: 'basic', options: {
                cls: "dq-chara-box",
                left: '9em',
                top: '2em',
                width: '12em',
                height: '8em',
                canSelect: false,
                showName: false,
                cancelNotHide: true
            }
            },
            { name: 'eqp', options: {
                left: '9em',
                top: '12em',
                width: '12em',
                canSelect: false,
                showName: false,
                cancelNotHide: true
            }
            },
            { name: 'status', options: {
                cls: "dq-sts-box",
                left: '21em',
                top: '2em',
                width: '9em',
                height: '16em',
                canSelect: false,
                cancelNotHide: true
            }
            }]);

        this._create(options);
    },
    {
        onEquip: null,
        _create: function (options) {
            var _player = null,
                _equip = null,
                _listType = null,
                _uid = -1,
                _serial = 0,
                _eqp = 0,
                me = this,
            party_toString = function (party) {
                var data = [];
                for (var i = 0; i < party.length; i++) {
                    data.push({ text: party[i].name });
                }
                return data;
            },
            getCurrent = function (player) {
                var eq = [],
                    eqps = _player.getEquipmentString();
                eq.push({ 'text': ['<span class="dq-icon dq-icon-wep">&nbsp;</span><span class="dq-exp-label">' + _('Weapon') + '：</span><span class="dq-eqp-value">', eqps[2], '</span>'].join('') });
                eq.push({ 'text': ['<span class="dq-icon dq-icon-wep">&nbsp;</span><span class="dq-exp-label">' + _('Armor') + '：</span><span class="dq-eqp-value">', eqps[1], '</span>'].join('') });
                eq.push({ 'text': ['<span class="dq-icon dq-icon-wep">&nbsp;</span><span class="dq-exp-label">' + _('Shield') + '：</span><span class="dq-eqp-value">', eqps[5], '</span>'].join('') });
                eq.push({ 'text': ['<span class="dq-icon dq-icon-wep">&nbsp;</span><span class="dq-exp-label">' + _('Accesary') + '：</span><span class="dq-eqp-value">', eqps[6], '</span>'].join('') });

                return eq;
            },
            getStatus = function (player) {
                return [
                { text: ['<span class="dq-sts-label">', 'ちから', '：</span><span  class="dq-sts-value">', player.getState('STR'), '</span>'].join('') },
                { text: ['<span class="dq-sts-label">', 'たいりょく', '：</span><span  class="dq-sts-value">', player.getState('VIT'), '</span>'].join('') },
                { text: ['<span class="dq-sts-label">', 'すばやさ', '：</span><span  class="dq-sts-value">', player.getState('AGI'), '</span>'].join('') },
                { text: ['<span class="dq-sts-label">', 'きようさ', '：</span><span  class="dq-sts-value">', player.getState('DEX'), '</span>'].join('') },
                { text: ['<span class="dq-sts-label">', 'かしこさ', '：</span><span  class="dq-sts-value">', player.getState('WIS'), '</span>'].join('') },
                { text: ['<span class="dq-sts-label">', 'ちえ', '：</span><span  class="dq-sts-value">', player.getState('INT'), '</span>'].join('') },
                { text: ['<span class="dq-sts-label">', 'かっこよさ', '：</span><span  class="dq-sts-value">', player.getState('CHA'), '</span>'].join('') },
                { text: ['<span class="dq-sts-label">', 'つよさ', '：</span><span  class="dq-sts-value">', player.getAttack(), '</span>'].join('') },
                { text: ['<span class="dq-sts-label">', 'まもり', '：</span><span  class="dq-sts-value">', player.getDefence(), '</span>'].join('') }
            ];
            },
            getBasic = function (player) {
                return [
                { text: player.name },
                { text: ['<span class="dq-chara-label">', '称号', '：</span><span class="dq-exp-value">', player.title, '</span>'].join('') },
                { text: ['<span class="dq-chara-label">', '職業', '：</span><span class="dq-exp-value">', player.occupation, '</span>'].join('') },
                { text: ['<span class="dq-chara-label">', 'レベル', '：</span><span class="dq-exp-value">', player.LV, '</span>'].join('') },
                { text: ['<span class="dq-chara-label">', 'ＨＰ', '：</span><span class="dq-exp-value">', player.hp(), '/', player.maxHP(), '</span>'].join('') },
                { text: ['<span class="dq-chara-label">', 'ＭＰ', '：</span><span class="dq-exp-value">', player.mp(), '/', player.maxMP(), '</span>'].join('') },
                { text: ['<span class="dq-chara-label">', 'Exp', '：</span><span class="dq-exp-value">', player.EXP, '</span>'].join('') },
                { text: ['<span class="dq-chara-label">', 'G', '：</span><span class="dq-exp-value">', world.party.G, '</span>'].join('') }
            ];
            };

            //だれ
            this._group.who.setData(party_toString(world.party));
            if (options.parentMenu) {
                options.parentMenu.setSubItem(this._group.who);
            }

            //装備選択肢
            this._group.onVisibleChanged = function (group, sender, visible) {
                if (!visible && sender.name == "who") {
                    me.hide();
                }
            }
            this._group.onSelectedIndexChanged = function (group, sender, pos) {
                if (sender.name == "who") {
                    _player = world.party[pos];
                    group.eqp.setData(getCurrent(_player));
                    group.basic.setData(getBasic(_player));
                    group.status.setData(getStatus(_player));
                    var icons = $('.dq-icon', group.eqp.obj);
                    $(icons[0]).css('background', DQ.RPG.Icon.getBackground(1, 0));
                    $(icons[1]).css('background', DQ.RPG.Icon.getBackground(0, 13));
                    $(icons[2]).css('background', DQ.RPG.Icon.getBackground(0, 12));
                    $(icons[3]).css('background', DQ.RPG.Icon.getBackground(0, 20));
                }
            }
        },
        player: null,
        show: function () {
            __dqsuper__(this, "show", arguments);

            this._group.who.show();
            this._group.eqp.show();
            this._group.basic.show();
            this._group.status.show();

            this._group.who.select();
            this.onVisibleChanged && this.onVisibleChanged(this, true);
        },
        onVisibleChanged: null,
        hide: function () {
            if (!this._visible) {
                return;
            }
            __dqsuper__(this, "hide", arguments);

            this._group && this._group.hide();
            this.onVisibleChanged && this.onVisibleChanged(this, false);
        }
    }, {
    });

    DQ.RPG.ConfigBox = dqextend(DQ.Control, function (screen, options) {
        /// <summary>
        /// 魔法選択ボックスを作成します。
        /// </summary>

        options = DQ.options(options, {
            showName: false,
            canSelect: true,
            top: DQ.T1,
            player: null
        });

        this.player = options.player;
        this.onChant = options.chant;
        this.base(screen, $('<div>').css('z-index', 999));

        this._group = new DQ.StateGroup(screen, [
            { name: 'what', options: {
                left: '3em',
                top: '4em',
                width: '8em',
                canSelect: true,
                text: _("Config")
            }
            },
            {
                name: 'to', options: {
                    width: '6em',
                    height: 'auto',
                    left: '10em',
                    top: '5em',
                    canSelect: true,
                    text: _("Slot")
                }
            },
            {
                name: 'config', options: {
                    width: '30em',
                    height: '20em',
                    left: DQ.L1,
                    top: DQ.T1,
                    canSelect: false,
                    text: _("To")
                }
            }]);

        var me = this,
            _pos,
            _mgc,
            _player,
            _pPos,
            _toPos;

        //なに
        this._group.what.setData([{ 'text': _("Save") }, { 'text': _("Load") }, { 'text': _("Config"), enabled: false}]);
        this._group.to.setData([{ 'text': _("Slot#1") }, { 'text': _("Slot#2") }, { 'text': _("Slot#3")}]);
        if (options.parentMenu) {
            options.parentMenu.setSubItem(this._group.what);
        }

        this._group.onVisibleChanged = function (group, sender, state) {
            if (sender.name == "what") {
                if (!state) {
                    group.hide();
                }
            }
            if (!state && sender.name == "to") {
                group.focus("what");
            }
        }
        this._group.onClick = function _group_onClick(group, sender) {
            /// <summary>
            ///   　コンフィグの実行
            /// </summary> 
            if (sender.name == "what") {
                _pos = sender.selectedIndex();
                if (_pos == 0 || _pos == 1) {
                    group.to.show();
                    group.focus("to");
                } else {
                    group.config.show();
                    group.focus("config");
                }
            } else if (sender.name == "to") {
                _toPos = sender.selectedIndex();
                if (_pos == 0) {
                    me.onSave && me.onSave(me, _toPos);
                } else {
                    var result = false;
                    if (me.onLoad) {
                        result = me.onLoad(me, _toPos);
                    }
                    if (result) {
                        world.jump(world.data['map' + _toPos], parseInt(world.data['X' + _toPos]), parseInt(world.data['Y' + _toPos]));
                        group.hide();
                    }
                }
                sender.hide();
            }
        };
        this._group.onLeave = function (group, sender) {
        }

    }, {
        dqid: "DQ.RPG.ConfigBox",
        onChant: null,
        setup: function (player) {
            player = (player instanceof DQ.RPG.Creature) ? player : this.player;
            this.player = player;

            var mg = [];
            for (var i = 0; i < player.magicIDs.length; i++) {
                mg.push({
                    'text': world.magics.catalog[player.magicIDs[i]].text,
                    'orgPos': i
                });
            }
            if (mg.length == 0) {
                return false;
            }
            this._group.magic.setData(mg);

            return true;
        },
        show: function (player) {
            __dqsuper__(this, "show", arguments);

            this._group.what.show();
            this._group.focus("what");
            this.onVisibleChanged && this.onVisibleChanged(this, true);
        },
        hide: function () {
            if (!this._visible) {
                return;
            }
            __dqsuper__(this, "hide", arguments);
            this._group && this._group.hide();
            this.onVisibleChanged && this.onVisibleChanged(this, false);
        }
    },
        {});

});