﻿/// <reference path="../jquery.js" />
/// <reference path="../dq.js" />
/// <reference path="../ui/dq-ui.js" />
/// <reference path="dq-rpg.js" />
/*
** DQ Retro game UI framework JavaScript library version v0.6.0
**
** Copyright (c) 2009-2010 M., Koji
** Licensed under the MIT License: http://www.opensource.org/licenses/mit-license.php
**
** Date: 2010-04-01 17:34:21 -0900
** Revision: 0005
**
**/

DQ.lazyLoad(DQ.subdir + "rpg/dq-rpg.js", "DQ.RPG.InputBox", function () {
    DQ.RPG.Visual = function () {
        ///<summary>
        /// 普段の画面のメニュー類を表示します。
        ///</summary>
    }

    DQ.RPG.Visual.prototype = {
        commandBox: null,
        lvBox: null,
        _slideUp: false,
        showLvBox: function () {
            this.lvBox.show();

        },
        slideDownLvBox: function () {
            this.lvBox.slideDown();
            //this.lvBox.update();
            this._slideUp = false;
        },
        slideUpLvBox: function () {
            if (this._slideUp) {
                return;
            }
            this.lvBox.slideUp();
            this._slideUp = true;
        },
        updateLvBox: function () {
            this.lvBox.update();
            this.lvBox.bringToFront();
        },
        setup: function (small) {
            var sc = world.screen;

            //メニュー位置を画面サイズに応じて調整
            DQ.L1 /= DQ.SCALE;
            DQ.L2 /= DQ.SCALE;
            DQ.LV2 /= DQ.SCALE;
            DQ.L3 /= DQ.SCALE;
            DQ.L4 /= DQ.SCALE;

            DQ.T1 /= DQ.SCALE;
            DQ.T2 /= DQ.SCALE;
            DQ.T3 /= DQ.SCALE;
            DQ.T4 /= DQ.SCALE;
            DQ.T5 /= DQ.SCALE;


            //主人公表示
            var pn = world.project ? world.project.name + "/" : "";
            if (small) {
                world.chara = new DQ.Chara(sc, {
                    delta: 2 * DQ.QUORITY,
                    uid: 10002,
                    top: (DQ.OY - 1) * 16 - 8,
                    left: (DQ.OX - 1) * 16,
                    cls: 'dq-chara-16px',
                    offset: 16
                });
            } else {
                world.chara = new DQ.Chara(sc, {
                    delta: 2 * DQ.QUORITY,
                    uid: 10001,
                    cls: "dq-chara-32",
                    xoffset: 32,
                    yoffset: 48,
                    top: (DQ.OY - 1) * 32,
                    left: (DQ.OX - 1) * 32
                });
            }

            //メッセージボックス
            this.msgBox = new DQ.MessageBox(sc, {
                width: '30em',
                height: '4.5em',
                left: 0,
                top: 312 / DQ.SCALE,
                clickImage: '../images/click.gif',
                canSelect: true,
                autoClose: true,
                enterKey: 86
            });
            world.screen.msgBox(this.msgBox);

            this.commandBox = new DQ.StateBox(sc, '9em', 'auto', {
                left: DQ.L1, top: DQ.T1, showName: false, canSelect: true,
                column: 2,
                data: [
                { text: _("ITEM"), callback: world.itemMenu }, { text: _("SPELL"), callback: world.magicMenu },
                { text: _("EQUIP."), callback: world.equipmentMenu }, { text: _("SEARCH"), callback: world.searchMenu },
                { text: _("STATUS"), callback: world.statusMenu }, { text: _("CONFIG"), callback: world.configMenu}],
                text: ""
            });


            this.lvBox = new DQ.RPG.LevelBox(world.screen, {
                width: '6.5em',
                height: 'auto',
                player: world.party[0],
                party: world.party,
                left: (1 + 7 * 0) + 'em',
                top: DQ.T1
            });

            DQ.chain.push(this.lvBox);
        }
    }
});