﻿/// <reference path="../jquery.js" />
/// <reference path="../dq.js" />
/// <reference path="dq-ui.js" />
/*
* DQ Retro game UI framework JavaScript library version v0.6.0
*
* Copyright (c) 2009 M., Koji
* Licensed under the MIT License: (http://www.opensource.org/licenses/mit-license.php)
*
* Date: 2009-11-01 17:34:21 -0900
* Revision: 0002
*/

DQ.lazyLoad(DQ.subdir + "ui/dq-ui.js", "DQ.UI", function () {
    DQ.UI.Progressbar = dqextend(DQ.Control, function (parent, options, object) {

        options = options || {};
        object = object || $('<div class="dq-progress">');
        var img = options.image || "images/progress.png";

        this.base(parent, object);

        var d = $('<div class="bar" />').appendTo(this.obj);
        this.client = $('<img />').attr('src', img).appendTo(d).width(0);
        this.txtObj = $('<div class="text" />').appendTo(this.obj);
    }, {
        text: function (value) {
            if (!arguments.length) {
                return this._text;
            } else {
                this._text = value;
                this.txtObj.text(value);
            }
        },
        update: function () {
            this.client.width(Math.floor(this.obj.width() / (this._maximum - this._minimum) * this._value));
            this.text(this._value);
        }
    }, {
        minimum: { get: function () { return this._minimum; }, set: function (value) { this._minimum = value; this.update(); }, def: 0 },
        maximum: { get: function () { return this._maximum; }, set: function (value) { this._maximum = value; this.update(); }, def: 100 },
        value: {
            get: function () { return this._value; },
            set: function (value) {
                if (value >= this._maximum) {
                    this._value = this._maximum;
                } else if (value <= this._minimum) {
                    this._value = this._minimum;
                } else {
                    this._value = value;
                }
                this.update();
            }, def: 0
        }
    });
});