﻿/// <reference path="../jquery.js" />
/// <reference path="../dq.js" />
/// <reference path="dq-ui.js" />

/*
* DQ Retro game UI framework JavaScript library version v0.6.0
*
* Copyright (c) 2009 M., Koji
* Licensed under the MIT License: http://www.opensource.org/licenses/mit-license.php
*
* Date: 2009-11-01 17:34:21 -0900
* Revision: 0004
*/
DQ.lazyLoad(DQ.subdir + "ui/dq-ui.js", "DQ.UI", function () {
    DQ.UI.HorizontalAlignment = { Left: 0, Right: 1, Celter: 2 }
    DQ.UI.TextBox = dqextend(DQ.Control, function (parent, options, object) {
        /// <summary>
        /// TextBoxコントロールを作成します。
        /// </summary>
        ///<param name="options" type="object">
        /// オプションを指定
        ///</param>
        /// <param name="object" type="jQuery">
        /// TextBoxコントロールの外殻を指すオブジェクトを指定
        /// </param>

        options = DQ.options(options, {
            caption: "",
            cls: "dq-textbox",
            name: "",
            tabIndex: 0,
            top: 0,
            left: 0,
            width: '5em',
            text: "",
            textAlign: DQ.UI.HorizontalAlignment.Left,
            onTextChanged: null,
            onEnter: null,
            onLeave: null
        });
        object = object || $('<div>').addClass(options.cls).width(options.width);
        this.base(parent, object);
        this.name = options.name;
        var cl = this.obj.children();
        this.client = cl.length ? cl : $('<input>').attr('type', "text");
        this.client.addClass('inner').attr('name', this.name).appendTo(this.obj);
        this.onTextChanged = options.onTextChanged;

        var style = this.obj[0].currentStyle || document.defaultView.getComputedStyle(this.obj[0], ''),
            w = style.width == 0 ? this.obj.css('width') : style.width,
            caption = this.caption = options.caption;

        this.client.width(w);
        this.obj.css({ top: options.top, left: options.left });
        cl.length && (this._multiline = cl[0].node == "TEXTAREA");
        var me = this;
        this.client.change(function (e) {
            me.onTextChanged && me.onTextChanged(me, e);
        });
        this.tabIndex(options.tabIndex);

        this.client.css('text-align', 'left');
        this.textAlign(options.textAlign);
        this.text(options.text);
        this.caption != "" && options.text == "" && this.setCaption();
    },
{
    setCaption: function () {
        if (this.caption) {
            this.text(this.caption);
            this.client.addClass('dq-cap');
        }
        this.client.bind("focusin", this, function (e) {
            var me = e.data;
            if (me.client.hasClass('dq-cap')) {
                me.text("");
                me.client.removeClass('dq-cap');
            }
            me.client[0].select();
        })
        .bind("focusout", this, function (e) {
            var me = e.data;
            if (!me.text()) {
                //me.client[0].select(0, 0);
                me.client.addClass('dq-cap');
                me.text(me.caption);
            }
        });
    },
    dispose: function () {
        /// <summary>
        /// リソースを破棄します
        /// </summary>
        this.client && this.client.remove() && this.client.unbind("click").unbind("focusin").unbind("focusout");
    },
    onEnter: null,
    onLeave: null,
    onTextChanged: null,
    text: function (value) {
        if (!arguments.length) {
            return this.client.attr('value');
        }
        this.client.attr('value', value);
    },
    _textAlign: DQ.UI.HorizontalAlignment.Left,
    textAlign: function (value) {
        if (arguments.length == 0) {
            return value;
        }
        if (value == this._textAlign) {
            return;
        }

        this._textAlign = value;
        var align;
        switch (value) {
            case DQ.UI.HorizontalAlignment.Left:
                align = 'left';
                break;
            case DQ.UI.HorizontalAlignment.Right:
                align = 'right';
                break;
            case DQ.UI.HorizontalAlignment.Center:
                align = 'center';
                break;
        }
        this.client.css('text-align', align);
    },
    _multiline: false,
    multiline: function (value) {
        if (!arguments.length) {
            return;
        }
        if (this._multiline != value) {
            this._multiline = value;
            this.dispose();
            if (!value) {
                this.client = $('<input>').attr('type', "text").appendTo(this.obj);
            } else {
                this.client = $('<textarea>').appendTo(this.obj);
                var h = this.obj.height() == 0 ? this.obj.css('height') : this.obj.height();
                this.client.height(h);
            }
            this.setCaption();
            this.client.addClass('inner').attr('name', this.name).appendTo(this.obj);
            var w = this.obj.width() == 0 ? this.obj.css('width') : this.obj.width();
            this.client.width(w);

            var me = this;
            this.client.change(function (e) {
                me.onTextChanged && me.onTextChanged(me, e);
            });
        }
    }
},
{});
    DQ._ctrl_['dq-textbox'] = DQ.UI.TextBox;
});
