﻿/// <reference path="../jquery.js" />
/// <reference path="../dq.js" />
/// <reference path="../dq-core.js" />
/// <reference path="dq-ui.js" />
/// <reference path="dq-button.js" />

/*
** DQ Retro game UI framework JavaScript library version v0.6.0
**
** Copyright (c) 2009 M., Koji
** Licensed under the MIT License: http://www.opensource.org/licenses/mit-license.php
**
** Date: 2009-11-01 17:34:21 -0900
** Revision: 0003
**
**/

DQ.lazyLoad(DQ.subdir + "ui/dq-ui.js", "DQ.UI.Form", function () {
    DQ.UI.LayoutTable = dqextend(DQ.UI.Panel, function (parent, options, object) {
        options = DQ.options(options, {
        });
        this.base(parent, options, object);

        this.__create(options);
    },
    {
        __create: function (options) {
            this.table = $('<table>').addClass('dq-fill').appendTo(this.client);
            this._tb = $('<tbody>').appendTo(this.table);

            options.data && this.setData(options.data);
        },
        setData: function (data) {
            this._tb.text('');
            for (var i = 0; i < data.length; i++) {
                var cur = data[i];
                var tr = $('<tr>').appendTo(this._tb);
                if (cur.label) {
                    var label = $('<label>').text(cur.label);
                    cur.accessKey && label.attr({ accessKey: cur.accessKey, name: cur.name })
                    tr.append($('<td>').append(label));
                }
                var obj = data[i].control instanceof DQ.Control ? data[i].control.obj : data[i].control;
                tr.append($('<td>').append(obj));
            }
        }
    });

    DQ.UI.SubDialog = dqextend(DQ.UI.Form, function (parent, options, object) {
        options = DQ.options(options, {
            width: 200,
            height: 150,
            startPosition: DQ.UI.FormStartPosition.CenterScreen,
            windowState: DQ.UI.FormWindowState.Normal,
            minimizeBox: false,
            maximizeBox: false,
            onClosing: function (sender) {
                sender.hide();
            }
        });
        var back = options.initializeComponent;
        var me = this;
        options.initializeComponent = function (sender) {
            me.buttonPanel = new DQ.UI.Panel(me, { height: 28 });
            me.buttonPanel.dock(DQ.UI.DockStyle.Bottom);
            me.buttonPanel.css({ 'border-top': '1px solid ActiveBorder', 'margin-top': '4px', 'text-align': 'right' });

            me.contentPanel = new DQ.UI.LayoutTable(me);
            me.contentPanel.dock(DQ.UI.DockStyle.Fill);

            me.accept = new DQ.UI.Button(me.buttonPanel, {
                cls: "dq-button-inline",
                text: _("OK"),
                width: '5em',
                click: function (sender) {
                    me.hide();
                }
            });
            me.acceptButton(me.accept);

            me.cancel = new DQ.UI.Button(me.buttonPanel, {
                cls: "dq-button-inline",
                text: _("Cancel"),
                width: '6em',
                click: function (sender) {
                    me.hide();
                }
            });
            me.cancelButton(me.cancel);

            back && back(sender);
        }

        this.base(parent, options, object);

    },
    {
    });

    DQ.UI.ProgressDialog = dqextend(DQ.UI.Form, function (parent, options, object) {
        options = DQ.options(options, {
            width: 200,
            height: 150,
            startPosition: DQ.UI.FormStartPosition.CenterScreen,
            windowState: DQ.UI.FormWindowState.Normal,
            minimizeBox: false,
            maximizeBox: false,
            onClosing: function (sender) {
                //sender.hide();
            }
        });
        var back = options.initializeComponent;
        var me = this;
        options.initializeComponent = function (sender) {
            me.buttonPanel = new DQ.UI.Panel(me, { height: 28 });
            me.buttonPanel.dock(DQ.UI.DockStyle.Bottom);
            me.buttonPanel.css({ 'border-top': '1px solid ActiveBorder', 'margin-top': '4px', 'text-align': 'right' });

            me.contentPanel = new DQ.UI.LayoutTable(me);
            me.contentPanel.dock(DQ.UI.DockStyle.Fill);

            me.cancel = new DQ.UI.Button(me.buttonPanel, {
                cls: "dq-button-inline",
                text: _("Cancel"),
                width: '6em',
                click: function (sender) {
                    DQ.abort();
                    me.hide();
                }
            });
            me.cancelButton(me.cancel);

            back && back(sender);
        }

        this.base(parent, options, object);

    },
    {
    });
});